︠e3c21d2a-0728-4bab-a232-9430ac45f1a5s︠
%html 
<h3>
    Code demonstration for Tamari interval-posets in Sage
</h3>
<p>
    This code is related to the paper:<br />
    [1] Grégory Châtel and Viviane Pons. <a href="http://arxiv.org/abs/1311.3922">Counting smaller elements in the Tamari and m-Tamari lattices</a>, to appear in Journal of Combinatorial Theory, Series A.
</p>
︡c528e2d9-a8f6-44d3-9886-6a347053e419︡{"html":"<h3>\n    Code demonstration for Tamari interval-posets in Sage\n</h3>\n<p>\n    This code is related to the paper:<br />\n    [1] Grégory Châtel and Viviane Pons. <a href=\"http://arxiv.org/abs/1311.3922\">Counting smaller elements in the Tamari and m-Tamari lattices</a>, to appear in Journal of Combinatorial Theory, Series A.\n</p>\n"}︡
︠060fad4c-8cc5-4c11-9860-d7259a11fd66︠
︡22d1866f-95e6-4007-96d2-40297e4ea900︡
︠d06a809c-ee81-441f-b8e6-057b48913475is︠
%html
<p>
    Creating an interval-poset.
</p>
︡6dd6df0c-34a5-4b48-94c5-3840d17102b4︡{"html":"<p>\n    Creating an interval-poset.\n</p>\n"}︡
︠d63c0e9b-6981-4740-af5b-8b96e8a19e22s︠
def latex_view(obj):
    return latex.eval(latex(obj))
︡d6d1d3b0-67d9-45cc-85ae-aab056edd2fb︡
︠a54db53c-d3d2-4c26-ba92-bb6b08c97283s︠
ip = TamariIntervalPoset(4,[(2,1),(3,1),(2,4),(3,4)]); ip
︡1056fa22-654b-4f16-bd06-97fdc612dc95︡{"stdout":"The tamari interval of size 4 induced by relations [(2, 4), (3, 4), (3, 1), (2, 1)]\n"}︡
︠1a72fb24-69f3-495f-b922-e12247da8051s︠
latex_view(ip)
︡a7f793e5-1bee-4036-b9e4-e580d84b94b1︡{"once":false,"file":{"show":true,"uuid":"43a8de4f-0816-4e27-9650-f7a7faf556ec","filename":"/tmp/tmp3AJVYJ.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡
︠21d4288d-43c9-4aa6-b371-1b181c2de153is︠
%html
<p>
    Creating from a binary tree or a Dyck path.
</p>
︡999f0a0c-4a96-460a-adc0-d6d3910fb647︡{"html":"<p>\n    Creating from a binary tree or a Dyck path.\n</p>\n"}︡
︠9618f42f-e5f1-4d2b-b20a-45794cf6a114s︠
bt1 = BinaryTree([[None, [[], None]], None])
bt2 = BinaryTree([None, [[None, []], None]])
ip = TamariIntervalPosets.from_binary_trees(bt1,bt2)
ip
︡6a19c427-35c8-4fda-b5fb-7b9575696f84︡{"stdout":"The tamari interval of size 4 induced by relations [(2, 4), (3, 4), (3, 1), (2, 1)]\n"}︡
︠59239a95-5e62-4802-88af-205422160b8as︠
ip = bt1.tamari_interval(bt2)
ip
︡4894c3eb-6f46-4497-8ad1-bffa3a4a2f0d︡{"stdout":"The tamari interval of size 4 induced by relations [(2, 4), (3, 4), (3, 1), (2, 1)]\n"}︡
︠ee21a302-497d-4a81-8c73-a8c908572ff2s︠
dw1 = DyckWord([1, 1, 0, 1, 0, 0, 1, 0])
dw2 = DyckWord([1, 1, 1, 0, 0, 1, 0, 0])
ip = TamariIntervalPosets.from_dyck_words(dw1,dw2)
ip
︡5bd2932b-431d-4544-b259-052642e156af︡{"stdout":"The tamari interval of size 4 induced by relations [(2, 4), (3, 4), (3, 1), (2, 1)]\n"}︡
︠178c82c7-59fd-42c8-aa4f-5b1f0e6fac95s︠
ip = dw1.tamari_interval(dw2)
ip
︡4d6f82f3-700f-4cd4-822a-e311309370c0︡{"stdout":"The tamari interval of size 4 induced by relations [(2, 4), (3, 4), (3, 1), (2, 1)]\n"}︡
︠c24f212d-e779-46d9-a1ff-d1bc7c3c6ee4︠

︡49bab056-1662-4f63-9692-f0949070d860︡
︠5ebbc12e-38fc-4e06-88ce-26634b446582is︠
%html
<p>
    Computing its endpoints as binary trees and list the binary trees of the interval.
</p>
︡399c3c1d-f474-4b65-8b46-54fed190b5a0︡{"html":"<p>\n    Computing its endpoints as binary trees and list the binary trees of the interval.\n</p>\n"}︡
︠01dcf3e1-128a-409d-a8ad-462c437d46dds︠
ip.lower_binary_tree()
ip.upper_binary_tree()
︡d3e7c804-8819-4b1b-96d7-1d76cea3b557︡{"stdout":"[[., [[., .], .]], .]\n"}︡{"stdout":"[., [[., [., .]], .]]\n"}︡
︠7a6cd8f0-8210-4f87-b616-40ebb7658650s︠
latex_view(ip.lower_binary_tree())
latex_view(ip.upper_binary_tree())
︡a6845287-e8b7-46d0-9a6b-05ebf209a3d2︡{"once":false,"file":{"show":true,"uuid":"caac4f8b-e34a-4555-882a-4559df4b8f3b","filename":"/tmp/tmpVwU6TL.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"5de35612-b4e9-4985-af74-83b48f47ec30","filename":"/tmp/tmpWHC4zH.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡
︠9e2f3ee7-95fe-4b7e-aaee-bafa8aeb641ds︠
for bt in ip.binary_trees():
    bt
︡d61f2bda-5b5b-4914-9864-c2a352a4744d︡{"stdout":"[., [[., [., .]], .]]\n[[., [., [., .]]], .]\n[., [[[., .], .], .]]\n[[., [[., .], .]], .]\n"}︡
︠b95c9bfc-7f43-4c46-ba66-97ccc93b533dis︠
%html
Computing its end points as Dyck paths and list the Dyck path of the interval.
︡1dc29f71-d898-4252-8f61-ac50cd187d16︡{"html":"Computing its end points as Dyck paths and list the Dyck path of the interval.\n"}︡
︠e2481ad9-7bd8-4187-b673-e067fa44ab03s︠
ip.lower_dyck_word()
ip.upper_dyck_word()
︡f0ce3615-7c16-4ad6-96fc-0054ce5e5236︡{"stdout":"[1, 1, 0, 1, 0, 0, 1, 0]\n"}︡{"stdout":"[1, 1, 1, 0, 0, 1, 0, 0]\n"}︡
︠ec68ea5a-8458-40cc-88ca-792c914becd9︠
︡aad4091f-1167-440b-a78e-fe7eb5616aea︡
︠e015d604-0281-4924-8f8b-a7859a3813d7s︠
for dw in ip.dyck_words():
    dw
︡61d59319-ad42-4a54-9117-6014fd254c62︡{"stdout":"[1, 1, 1, 0, 0, 1, 0, 0]\n[1, 1, 1, 0, 0, 0, 1, 0]\n[1, 1, 0, 1, 0, 1, 0, 0]\n[1, 1, 0, 1, 0, 0, 1, 0]\n"}︡
︠876fb537-d837-4f95-8e9e-41ea5f3aabc3is︠
%html
<p>
    In [1], we define a <em>composition of interval-posets</em>. Below are the methods corresponding to this composition.
</p>
︡f7fb0a4e-3629-4a9d-82e9-05748c37fdc4︡{"html":"<p>\n    In [1], we define a <em>composition of interval-posets</em>. Below are the methods corresponding to this composition.\n</p>\n"}︡
︠40dd88f3-2593-4050-af70-3a71777a8b16s︠
def left_product(ip1,ip2):
    size = ip1.size() + ip2.size()
    # Juxtaposition of ip1 and shifted ip2
    relations = list(ip1._cover_relations) + [(i+ip1.size(),j+ip1.size()) for (i,j) in ip2._cover_relations]
    # Increasing relations between ip1 and the first vertex of ip2
    relations+= [(i,ip1.size()+1) for i in ip1.increasing_roots()]
    return TamariIntervalPoset(size,relations)
    
def right_product(ip1, ip2):
    size = ip1.size() + ip2.size()
    # Juxtaposition of ip1 and shifted ip2
    relations = list(ip1._cover_relations) + [(i+ip1.size(),j+ip1.size()) for (i,j) in ip2._cover_relations]
    # First element: no extra decreasing relation
    yield TamariIntervalPoset(size,relations)
    for j in ip2.decreasing_roots():
        # Adding decreasing relations 1 by 1
        relations.append((j+ip1.size(),ip1.size()))
        yield TamariIntervalPoset(size,relations)
        
def composition(ip1,ip2):
    u = TamariIntervalPoset(1,[])
    left = left_product(ip1,u)
    for r in right_product(left,ip2):
        yield r
︡f2b05d05-5fff-4faf-a95d-b0a053935205︡
︠3542329b-e73f-4ba7-9ef4-382ed15f6f0eis︠
%html
Here is an example of computation that corresponds to Figure 13 of [1].
︡5efce14f-91ae-4c19-8342-add4c3e0d7a2︡{"html":"Here is an example of computation that corresponds to Figure 13 of [1].\n"}︡
︠58571969-7002-4c8b-832f-a745da990e11s︠
ip1 = TamariIntervalPoset(3,[(1,2),(3,2)])
ip2 = TamariIntervalPoset(4,[(2,3),(4,3)])
r = list(composition(ip1,ip2))
r
︡fff2604b-099a-429e-bf85-68615b917f8f︡{"stdout":"[The tamari interval of size 8 induced by relations [(1, 2), (2, 4), (3, 4), (6, 7), (8, 7), (3, 2)], The tamari interval of size 8 induced by relations [(1, 2), (2, 4), (3, 4), (6, 7), (8, 7), (5, 4), (3, 2)], The tamari interval of size 8 induced by relations [(1, 2), (2, 4), (3, 4), (6, 7), (8, 7), (6, 4), (5, 4), (3, 2)], The tamari interval of size 8 induced by relations [(1, 2), (2, 4), (3, 4), (6, 7), (8, 7), (7, 4), (6, 4), (5, 4), (3, 2)]]\n"}︡
︠eb6be3f7-af26-46fc-993a-bc9581962a10s︠
for ipr in r:
    latex_view(ipr)
︡70cd3851-da72-4093-ba25-32ed655898ac︡{"once":false,"file":{"show":true,"uuid":"317ce557-da6f-4a6e-8e54-fa6edfb2f2c2","filename":"/tmp/tmpj7Psfo.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"eec184d8-d7fc-4131-9c20-030a2be336b6","filename":"/tmp/tmp5BaVqc.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"0b084505-5b43-4ac9-9474-ac7ccc2dcc25","filename":"/tmp/tmpD25uyR.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"2be6bf80-b460-47fa-86b5-7da6fbec47d4","filename":"/tmp/tmp_6d6a5.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡
︠8da74f28-0700-49ab-9e1b-60826545f6d7is︠
%html
There is also a $m$-composition defined in [1] which is implemented below.
︡c45e5dfe-c63a-437d-84bb-e00b8a90e216︡{"html":"There is also a $m$-composition defined in [1] which is implemented below.\n"}︡
︠3d4808d8-eb83-414e-8de2-49390f823ca4s︠
def right_product_dim(ip1,ip2):
    size = ip1.size() + ip2.size()
    # Juxtaposition of ip1 and shifted ip2
    relations = list(ip1._cover_relations) + [(i+ip1.size(),j+ip1.size()) for (i,j) in ip2._cover_relations]
    for j in ip2.decreasing_roots():
        # Adding decreasing relations 1 by 1
        relations.append((j+ip1.size(),ip1.size()))
        yield TamariIntervalPoset(size,relations)
        
def mcomposition(ips):
    rights = ips[1:] # we take the list of intervals excpect the first one
    def compute_rights(rights): # we define a recursive method to compute the right part
        u = TamariIntervalPoset(1,[])
        if len(rights)==1:
            for r in right_product(u,rights[0]):
                yield r
        else:
            for r1 in compute_rights(rights[1:]):
                r1 = left_product(r1,rights[0])
                for r2 in right_product_dim(u,r1):
                    yield r2
    for r in compute_rights(rights):
        yield left_product(ips[0],r)
︡c3f7ca52-a759-4136-9bb0-bf719c131b9d︡
︠d5d4ec4c-b8b8-4600-8c86-c88d5264d9ddis︠
%html
<p>
    Here is an example corresponding to (4.16) of [1].
</p>
︡8b005d21-a2a4-40fe-99d3-abf0b86f0547︡{"html":"<p>\n    Here is an example corresponding to (4.16) of [1].\n</p>\n"}︡
︠8684e049-d06f-44c6-9f71-747989c21b11s︠
ip1 = TamariIntervalPoset(2,[(2,1)])
ip2 = TamariIntervalPoset(4,[(2,1),(4,3),(2,3)])
ip3 = ip1
r = list(mcomposition([ip1,ip2,ip3]))
r
︡f1e58cb9-018a-4133-aa7a-ebf053eef403︡{"stdout":"[The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (8, 7), (6, 5), (4, 3), (2, 1)], The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (8, 7), (6, 5), (5, 3), (4, 3), (2, 1)], The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (8, 7), (7, 3), (6, 5), (5, 3), (4, 3), (2, 1)], The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (9, 3), (8, 7), (7, 3), (6, 5), (5, 3), (4, 3), (2, 1)], The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (8, 7), (6, 5), (5, 4), (4, 3), (2, 1)], The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (8, 7), (7, 3), (6, 5), (5, 4), (4, 3), (2, 1)], The tamari interval of size 10 induced by relations [(1, 3), (2, 3), (4, 7), (5, 7), (6, 7), (8, 9), (10, 9), (9, 3), (8, 7), (7, 3), (6, 5), (5, 4), (4, 3), (2, 1)]]\n"}︡
︠17f0b75c-a51b-42ba-826a-3d94641b7ea4s︠
for ipr in r:
    latex_view(ipr)
︡9f75dae4-4585-43a8-8b65-7fbc1d4caf4b︡{"once":false,"file":{"show":true,"uuid":"72cca0fc-3a93-4910-ac1c-b040955d9d36","filename":"/tmp/tmpzuM15i.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"57feffd1-868b-48b6-93f3-2de126ad2d5e","filename":"/tmp/tmpag1pQl.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"189c6738-b787-4a9b-aaf3-ea16aced47c3","filename":"/tmp/tmpnoCyVV.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"7a7014b9-d46b-4fd6-90af-80d804bd1dbb","filename":"/tmp/tmpBUBJGr.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"de36c83f-cba6-48f0-9b91-d31046d7a146","filename":"/tmp/tmp11pmEC.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"ffee2a81-1f95-4072-b565-108abe931e40","filename":"/tmp/tmpspjX96.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡{"once":false,"file":{"show":true,"uuid":"011eaf27-66db-45a7-b4bf-3e224827a45c","filename":"/tmp/tmpQAYtlT.png"}}︡{"stdout":"''"}︡{"stdout":"\n"}︡
︠ad63a9d9-d36d-4de7-8e55-f00167290f98︠









